import { returnWinner } from './utilities.js';
import { drawChart } from './drawchart'; 
import { buildSelectMenu } from './selectMenu'; 

// This is an example of an ES6 module.
export function generateData(){
  
  let data2012 = [];
  let data2018 = [];
    
  d3.csv('https://s3.amazonaws.com/interactives.dallasnews.com/data-store/2018/elections/texas-senate-2012.csv')
  .then(function(data) {
    	data.map((d) => {
        
        const obj2012 = {}
        
        obj2012.id = d.county;
        obj2012.year = 2012;
        obj2012.population = +d.pop2012;
        obj2012.voter_turnout = parseFloat(d.turnout.slice(0, -1));
        obj2012.pct_dem = parseFloat(d.democrat_pct.slice(0, -1));
        obj2012.pct_rep = parseFloat(d.republican_pct.slice(0, -1));
        obj2012.county_name = d.county;
        
        data2012.push(obj2012);
        
        const obj2018 = {}
        
        obj2018.id = d.county;
        obj2018.year = 2018;
        obj2018.population = +d.pop2012;
        obj2018.voter_turnout = Math.random()*(70-40+1)+40/10 + 10;
        obj2018.pct_dem = Math.floor(Math.random()*(70-30+1)+30);
        obj2018.pct_rep = 100 - obj2018.pct_dem;
        obj2018.county_name = d.county;
        
        data2018.push(obj2018);
                
      });
    
    const chartData = [...data2012, ...data2018];

    console.log('chartData', chartData);

    drawChart(chartData);
    buildSelectMenu(data2018);
  
  });
}

export function generateLineData(data){
  const lineData = [];
  const countyIDs = [...new Set(data.map(item => item.id))]; 
  countyIDs.map((d) => {

    const thisOne = data.filter( e => e.id === d );
    
    const thisObj = {}
    thisObj.id = d;
    thisObj.turnout2012 = thisOne[0].voter_turnout;
    thisObj.winner2012 = returnWinner(thisOne[0]);
    thisObj.turnout2018 = thisOne[1].voter_turnout;
    thisObj.winner2018 = returnWinner(thisOne[1]);
    
    console.log(thisObj)

    lineData.push(thisObj);
    
  });
  
  return lineData;
}